from __future__ import annotations
from tabnanny import verbose
from tvsc import settings
from tvsc.log import *
import argparse


class Args(argparse.Namespace):
    version: bool | None
    debug: bool | None
    verbose: bool | None


def main():
    argparser = argparse.ArgumentParser(
        settings.name, description="Compiler for tvsl.", add_help=True
    )

    argparser.add_argument(
        "-v",
        "--version",
        action="store_true",
        dest="version",
        help="show version and exit",
    )

    argparser.add_argument(
        "--debug", action="store_true", dest="debug", help="shows debug information"
    )

    argparser.add_argument(
        "--verbose", action="store_true", dest="verbose", help="shows extra information"
    )

    args: Args = argparser.parse_args()
    if args.debug:
        settings.debug = True
    else:
        settings.debug = False

    if args.verbose:
        settings.verbose = True
    else:
        settings.verbose = False

    if args.version:
        printf("%(name)s %(version)s", name=settings.name, version=settings.version)
        return

    settings.initialized = True
    debug("Arguments: %(a)s", a=str(args))
